package com.jniwrapper.win32.hook;

import com.jniwrapper.Parameter;
import com.jniwrapper.Structure;
import com.jniwrapper.UInt32;
import com.jniwrapper.win32.Point;

/**
 * This class represents the wrapper for <code>MSLLHOOKSTRUCT</code> native structure.
 */
class MouselHookStruct extends Structure
{
    private Point point = new Point();
    private UInt32 mouseData = new UInt32();
    private UInt32 flags = new UInt32();
    private UInt32 time = new UInt32();
    private UInt32 dwExtraInfo = new UInt32();

    public MouselHookStruct()
    {
        init(new Parameter[]{point, mouseData, flags, time, dwExtraInfo}, (short) 8);
    }

    public Object clone()
    {
        MouselHookStruct clone = new MouselHookStruct();
        clone.initFrom(this);
        return clone;
    }

    public Point getPoint()
    {
        return point;
    }

    public UInt32 getMouseData()
    {
        return mouseData;
    }

    public UInt32 getFlags()
    {
        return flags;
    }

    public UInt32 getTime()
    {
        return time;
    }

    public UInt32 getDwExtraInfo()
    {
        return dwExtraInfo;
    }
}
